import os
from typing import Union
from z.create import normalize_name
from argparse import ArgumentTypeError

def rename_file(source:str, dest:str, tags:str, date:Union[str, None] = None):
    ext = None
    if '.' in dest:
        os.rename(source, normalize_name(dest.split('.')[0], tags, time=date, ext=dest.split('.')[1]))
    else:
        if '.' in source:
            os.rename(source, normalize_name(dest, tags, time=date, ext=source.split('.')[1]))
        else:
            os.rename(source, normalize_name(dest, tags, time=date, ext=""))
                  
def main(args):
    tags = args.source.split("__")[1] if "--" in args.source else ""

    if args.timestamp:
        date = args.source.split("--")[0] if "--" in args.source else -1
        if date == -1:
            raise ArgumentTypeError("Timestamp option only works for source files that are formatted like Denote files.")
        rename_file(args.source, args.dest, tags, date=date)
    else:
        rename_file(args.source, args.dest, tags)

if __name__ == "__main__":
    main(None)
